## ecl 20.4.24+ds

=== msvc/Makefile ===
#
#		Makefile for ECoLisp
#
top_srcdir= ..\src
srcdir	= ..\src

# =============================================================
# ECL configuration
# <BEGIN>

SHORT_SITE_NAME   =
LONG_SITE_NAME    =
ECL_VERSION       = 20.4.24
ECL_VERSION_NUMBER= 200424
ARCHITECTURE      = PENTIUM4
SOFTWARE_TYPE     = NT
SOFTWARE_VERSION  = 5.0
THEHOST           = win32

# Size of the C stack in bytes
ECL_DEFAULT_C_STACK_SIZE = 1048576

# Define to 1 to make a 64-bit build
# ECL_WIN64 =

# Define here the processor type to compile GMP library
# with maximum optimization. Possible values are:
# 	gc -> generic implementation
# 	p0 -> Pentium processor
# 	p3 -> Pentium III processor
# 	p4 -> Pentium IV processor
#   amd64 -> X86_64 compatible processor
!if "$(GMP_TYPE)" == ""
GMP_TYPE = gc
!endif

# Set it to non-empty to include Win32 thread support
# Currently it is NOT SUPPORTED to build ECL without threads. The reason
# is that certain exception handlers in Windows always use new threads.
# Without them, ECL would be an even more fragile piece of software.
ECL_THREADS   = 1

# Set it to empty to remove support for Unicode characters
ECL_UNICODE = 1

# Set it to non-empty to enable Win32 debug support
#ECL_DEBUG = 1

# Set it to non-empty to support SSE2 intrinsics
ECL_SSE =

# Add the extensions to include in the build process. Comment any
# of the following lines to remove a feature from the build process
# LISP->C compiled
ECL_CMP     =
# ASDF support
ECL_ASDF    =
# TCP support
ECL_SOCKETS =
# Regression Tests support
ECL_RT      =
# Defsystem support
ECL_DEFSYS  =
# Profiling
ECL_PROFILE =
# Use the DbgHelp.lib shared library to provide C Backtrace support
ECL_USE_DBGHELP = $(ECL_DEBUG)

!if "$(YASM)" == ""
!if "$(ECL_WIN64)" != ""
YASM=yasm-1.3.0-win64.exe
!else
YASM=yasm-1.3.0-win32.exe
!endif
!endif

# <END> (ECL configuration)
# =============================================================

TAR_DIR = %CD%\ecl-$(ECL_VERSION)

# Programs used by "make":
#

CC	= cl
CLIBS   = user32.lib ws2_32.lib shell32.lib
STATICLIBS = eclgc.lib eclgmp.lib
LIBS	= $(STATICLIBS) $(CLIBS)
RM	= del
RMDIR   = rmdir /Q /S
MKDIR   = mkdir
EXE	= .exe
CP      = copy /Y
MV      = move /Y
MSDEV   = msdev
MKNSI   = makensis.exe


# ==================== Flags ====================

!if "$(ECL_WIN64)" != ""
GMP_BITS=64
GC_CPU=AMD64
ARCHITECTURE=AMD64
VCREDIST=vcredist_x64.exe
!else
GMP_BITS=32
GC_CPU=i386
ARCHITECTURE=PENTIUM4
VCREDIST=vcredist_x86.exe
!if "$(ECL_SSE)" != ""
CFLAGS_SSE=/arch:SSE2
!endif
!endif

#
# Configuration-specific (Debug/Release) options
#
!if "$(ECL_DEBUG)" != ""
CFLAGS_OPTIMIZE = /Od
CFLAGS_CONFIG = /Zi /D_DEBUG /MDd $(CFLAGS_OPTIMIZE) $(CFLAGS_SSE)
LDFLAGS_CONFIG = /debug
SHARED_LDFLAGS = /LDd
GCFLAGS =
!else
CFLAGS_OPTIMIZE = /O2
CFLAGS_CONFIG = /DNDEBUG /MD $(CFLAGS_OPTIMIZE) $(CFLAGS_SSE)
LDFLAGS_CONFIG = 
SHARED_LDFLAGS = /LD
GCFLAGS = nodebug=1
!endif

!if "$(ECL_USE_DBGHELP)" != ""
CLIBS = $(CLIBS) DbgHelp.lib
!endif

CFLAGS  = /EHsc /DGC_DLL /DGC_BUILD /nologo /D_CRT_SECURE_NO_DEPRECATE $(CFLAGS_CONFIG)
LDFLAGS	= /link /incremental:no /nologo $(LDFLAGS_CONFIG) /STACK:$(ECL_DEFAULT_C_STACK_SIZE)


# Additional configuration for thread support
#
!if "$(ECL_THREADS)" == ""
ENV_EXPORT = cl_env,DATA
!else
ENV_EXPORT = ecl_process_env
CFLAGS     = $(CFLAGS)
DEF        = ecl-threads.def
!endif

!MESSAGE C++ compiler flags: $(CFLAGS)
!MESSAGE C++ linker flags: $(LDFLAGS)

# ==================== Where To Install Things ====================

# The default location for installation.  Everything is placed in
# subdirectories of this directory.  The default values for many of
# the variables below are expressed in terms of this one, so you may
# not need to change them.  This defaults to /usr/local.
prefix=%CD%\package
exec_prefix=$(prefix)
bindir=$(prefix)
libdir=$(prefix)
includedir=$(prefix)
docdir=$(prefix)\doc

# Programs used by "make install":
#
SHELL = @SHELL@
INSTALL	= @INSTALL@
INSTALL_PROGRAM = @INSTALL_PROGRAM@
INSTALL_SCRIPT = @INSTALL_SCRIPT@
INSTALL_DATA = @INSTALL_DATA@
mkinstalldirs = $(top_srcdir)/bdwgc/install-sh -d

# Files
#
SUBDIR        = c gc gmp
LIBRARIES     =
TARGETS       = ecl2$(EXE)
DEF           = ecl.def

# Additional modules
# 
ECL_MODULES  =
ECL_FEATURES = (cons :wants-dlopen *features*)
!ifdef ECL_CMP
ECL_MODULES  = $(ECL_MODULES) cmp
ECL_FEATURES = (cons :wants-cmp $(ECL_FEATURES))
!endif
!ifdef ECL_ASDF
ECL_MODULES  = $(ECL_MODULES) asdf
ECL_FEATURES = (cons :wants-asdf $(ECL_FEATURES))
!endif
!ifdef ECL_SOCKETS
ECL_MODULES  = $(ECL_MODULES) sockets
ECL_FEATURES = (cons :wants-sockets $(ECL_FEATURES))
!endif
!ifdef ECL_RT
ECL_MODULES  = $(ECL_MODULES) rt
ECL_FEATURES = (cons :wants-rt $(ECL_FEATURES))
!endif
!ifdef ECL_DEFSYS
ECL_MODULES  = $(ECL_MODULES) defsystem
ECL_FEATURES = (cons :wants-defsystem $(ECL_FEATURES))
!endif
!ifdef ECL_PROFILE
ECL_MODULES  = $(ECL_MODULES) profile
ECL_FEATURES = (cons :wants-profile $(ECL_FEATURES))
!endif
ECL_MODULES  = $(ECL_MODULES) bytecmp
ECL_FEATURES = (list* :builtin-bytecmp :wants-bytecmp $(ECL_FEATURES))
ECL_MODULES  = $(ECL_MODULES) ecl-curl
ECL_FEATURES = (cons :wants-ecl-curl $(ECL_FEATURES))
ECL_MODULES  = $(ECL_MODULES) deflate
ECL_FEATURES = (cons :wants-deflate $(ECL_FEATURES))

!MESSAGE ECL Modules: $(ECL_MODULES)
!MESSAGE ECL Features: $(ECL_FEATURES)

# Build rules
# 
all:	$(TARGETS) ecl-config.bat ecl-cc.bat
.PHONY:	all

%Makefile: $(srcdir)/%Makefile.in config.status
	./config.status

c\cut$(EXE): $(top_srcdir)\util\cut.c
	cd c
	$(MAKE) cut$(EXE)
	cd ..

$(TARGETS): $(UCDDAT) ecl_min$(EXE) compile.lsp sysfun.lsp BUILD-STAMP
	set ECLDIR=./
	ecl_min < compile.lsp
BUILD-STAMP: Makefile
	date /t > $@

ecl-static.lib: $(TARGETS)
	link /lib /out:$@ eclmin.lib c\all_symbols2.obj lsp.lib eclgmp.lib eclgc.lib

ecl_min$(EXE): $(LIBRARIES) eclmin.lib
	$(CC) /Fe$@ cinit.obj c\all_symbols.obj eclmin.lib $(LDFLAGS) $(LIBS)
	if exist ecl_min$(EXE).manifest \
	 mt -manifest ecl_min.exe.manifest -outputresource:ecl_min.exe;1
	-$(RM) ecl_min.exp ecl_min.lib ecl_min$(EXE).manifest

.gdbinit: $(srcdir)\util\gdbinit
	$(CP) $(srcdir)\util\gdbinit $@

lsp/config.lsp: $(srcdir)/lsp/config.lsp.in Makefile c\cut$(EXE)
	if not exist lsp $(MKDIR) lsp
	c\cut "@ecldir\@" "$(libdir:\=/)" \
	    "@SHORT_SITE_NAME@" "$(SHORT_SITE_NAME)" \
	    "@LONG_SITE_NAME@" "$(LONG_SITE_NAME)" \
	    "@PACKAGE_VERSION@" "$(ECL_VERSION)" \
	    "@ARCHITECTURE@" "$(ARCHITECTURE)" \
	    "@SOFTWARE_TYPE@" "$(SOFTWARE_TYPE)" \
	    "@SOFTWARE_VERSION@" "$(SOFTWARE_VERSION)" \
	    "@thehost@" "$(THEHOST)" \
	    "@true_srcdir@" "$(srcdir:\=/)" \
	    "@top_srcdir@" "$(top_srcdir:\=/)/" \
	    < $(srcdir)\lsp\config.lsp.in > lsp\config.lsp
compile.lsp: bare.lsp $(srcdir)/compile.lsp.in Makefile
	c\cut "@ecldir\@" "$(libdir:\=/)" \
	    "@libdir\@" "$(libdir:\=/)" \
	    "@true_srcdir@" "$(srcdir:\=/)" \
	    "@true_builddir@" "$(MAKEDIR:\=/)" \
	    "@CFLAGS@" "$(CFLAGS) -DGC_BUILD" \
	    "@ECL_CFLAGS@" "" \
	    "@CPPFLAGS@" "" \
	    "@ECL_LDRPATH@" "" \
	    "@LDFLAGS@" "$(LDFLAGS)" \
	    "@SHARED_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@BUNDLE_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@CLIBS@" "$(CLIBS)" \
	    "@STATICLIBS@" "$(STATICLIBS)" \
	    "@LIBS@" "$(LIBS)" \
	    "@CORE_LIBS@" "" \
	    "@FASL_LIBS@" "" \
	    "@OBJEXT@" "obj" \
	    "@SHAREDPREFIX@" "" \
	    "@SHAREDEXT@" "lib" \
	    "@LIBPREFIX@" "" \
	    "@LIBEXT@" "lib" \
	    "@EXEEXT@" ".exe" \
	    "@LDINSTALLNAME@" "" \
	    "@DEF@" "$(DEF)" \
            "@RANLIB@" "ranlib" \
	    "@LSP_FEATURES@" "$(ECL_FEATURES)" \
	    "@ECL_CMPDIR@" "cmp" \
	    "@ECL_EXTRA_LISP_FILES@" "" \
	    "@ECL_INIT_FORM@" "(si::top-level t)" \
	    < $(srcdir)\compile.lsp.in > compile.lsp
bare.lsp: $(srcdir)/bare.lsp.in lsp/load.lsp clos/load.lsp cmp/load.lsp cmp/cmpdefs.lsp
	c\cut "@true_srcdir@" "$(srcdir:\=/)" \
	    "@top_srcdir@" "$(srcdir:\=/)" \
	    "@true_builddir@" "$(MAKEDIR:\=/)"\
	    "@ECL_CMPDIR@" "cmp" < $(srcdir)\bare.lsp.in > bare.lsp
lsp/load.lsp: $(srcdir)/lsp/load.lsp.in
	$(CP) $(srcdir)\lsp\load.lsp.in lsp\load.lsp
clos/load.lsp: $(srcdir)/clos/load.lsp.in
	if not exist clos $(MKDIR) clos
	$(CP) $(srcdir)\clos\load.lsp.in clos\load.lsp
cmp/load.lsp: $(srcdir)/cmp/load.lsp.in
	if not exist cmp $(MKDIR) cmp
	$(CP) $(srcdir)\cmp\load.lsp.in cmp\load.lsp
cmp/cmpdefs.lsp: $(srcdir)/cmp/cmpdefs.lsp Makefile
	c\cut "@ECL_CC@" "$(CC)" \
	    "@CFLAGS@" "$(CFLAGS)" \
	    "@CFLAGS_OPTIMIZE@" "$(CFLAGS_OPTIMIZE)" \
	    "@ECL_CFLAGS@" "" \
	    "@CPPFLAGS@" "" \
	    "@ECL_LDRPATH@" "" \
	    "@LDFLAGS@" "$(LDFLAGS)" \
	    "@SHARED_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@BUNDLE_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@CLIBS@" "$(CLIBS)" \
	    "@STATICLIBS@" "$(STATICLIBS)" \
	    "@OBJEXT@" "obj" \
	    "@SHAREDPREFIX@" "" \
	    "@SHAREDEXT@" "dll" \
	    "@LIBPREFIX@" "" \
	    "@LIBEXT@" "lib" \
	    "@EXEEXT@" ".exe" \
	    "@ecldir\@" "NIL" \
	    "@libdir\@" "NIL" \
	    "@includedir\@" "NIL" \
	    < $(srcdir)\cmp\cmpdefs.lsp > cmp\cmpdefs.lsp
ecl-config.bat: util\ecl-config.bat Makefile
	c\cut "~A" "$(libdir:\=/)"\
	    "~*" "" \
	    "@ECL_CFLAGS@" "$(CFLAGS)" \
	    "@LDFLAGS@" "$(LDFLAGS)" \
	    "@CLIBS@" "" \
	    "@libdir@" "$(prefix:\=/)" \
	    "@includedir@" "$(prefix:\=/)/ecl" \
	    < util\ecl-config.bat > ecl-config.bat
ecl-cc.bat: util\ecl-cc.bat Makefile
	c\cut "@ECL_CFLAGS@" "$(CFLAGS)" \
	      "@LDFLAGS@" "$(LDFLAGS)" \
	      "@CLIBS@" "" \
	      "@libdir@" "$(prefix:\=/)" \
	      "@includedir@" "$(prefix:\=/)/ecl" \
	      < util\ecl-cc.bat > ecl-cc.bat


eclmin.lib: eclgmp.lib eclgc.lib lsp/config.lsp
	cd c
	$(MAKE) /nologo ECL_VERSION_NUMBER=$(ECL_VERSION_NUMBER) \
                ECL_DEFAULT_C_STACK_SIZE=$(ECL_DEFAULT_C_STACK_SIZE) \
	        ECL_THREADS=$(ECL_THREADS) ECL_UNICODE=$(ECL_UNICODE) \
		ECL_SSE=$(ECL_SSE) ECL_WIN64=$(ECL_WIN64) \
		ECL_USE_DBGHELP=$(ECL_USE_DBGHELP) \
		"ECL_CFLAGS=$(CFLAGS) -DGC_BUILD"
	cd ..
eclgc.lib:
	cd gc
	$(MAKE) /nologo $(GCFLAGS) ECL_THREADS=$(ECL_THREADS) "CFLAGS_CONFIG=$(CFLAGS_CONFIG)" "MY_CPU=$(GC_CPU)" gc.lib
	$(CP) gc.lib ..\eclgc.lib
	cd ..
	if not exist ecl\gc $(MKDIR) ecl\gc
	if not exist ecl\gc\private $(MKDIR) ecl\gc\private
	for %h in (gc.h gc_version.h gc_local_alloc.h gc_pthread_redirects.h \
	           gc_config_macros.h leak_detector.h gc_typed.h \
	           private\gc_priv.h private\gcconfig.h gc_mark.h \
		   new_gc_alloc.h weakpointer.h gc_pthread_redirects.h) \
	    do $(CP) $(srcdir)\bdwgc\include\%h ecl\gc\%h

eclgmp.lib:
	cd gmp
	$(MAKE) /nologo "MPN_TYPE=$(GMP_TYPE)" "CFLAGS_CONFIG=$(CFLAGS_CONFIG)" \
		"BITS=$(GMP_BITS)" "YASM=$(YASM)"
	$(CP) gmp.lib ..\eclgmp.lib
	$(CP) gmp.h ..\ecl\gmp.h
	cd ..

sysfun.lsp:
	$(CP) $(srcdir)\cmp\sysfun.lsp .\

install:
	IF NOT EXIST "$(prefix)" $(MKDIR) "$(prefix)"
	IF NOT EXIST "$(bindir)" $(MKDIR) "$(bindir)"
	for %i in ($(TARGETS) ecl.dll) do $(CP) %i "$(bindir)\%i"
	IF EXIST "$(bindir)\ecl2$(EXE)" $(MV) "$(bindir)\ecl2$(EXE)" "$(bindir)\ecl$(EXE)"
	IF EXIST ecl2$(EXE).manifest $(CP) ecl2$(EXE).manifest "$(bindir)\ecl$(EXE).manifest"
	IF EXIST ecl.dll.manifest $(CP) ecl.dll.manifest "$(bindir)"
	$(CP) ecl-config.bat "$(bindir)\ecl-config.bat"
	$(CP) ecl-cc.bat "$(bindir)\ecl-cc.bat"
	IF NOT EXIST "$(includedir)\ecl" $(MKDIR) "$(includedir)\ecl"
	IF NOT EXIST "$(includedir)\ecl\impl" $(MKDIR) "$(includedir)\ecl\impl"
	IF NOT EXIST "$(includedir)\ecl\gc" $(MKDIR) $(includedir)\ecl\gc
	IF NOT EXIST "$(includedir)\ecl\gc\private" $(MKDIR) "$(includedir)\ecl\gc\private"
	for %i in (ecl\*.h ecl\impl\*.h ecl\gc\*.h ecl\gc\private\*.h) do $(CP) %i $(includedir)\%i
	IF EXIST "$(include)\ecl\atomic_ops" rmdir /S /Q "$(include)\ecl\atomic_ops"
	IF EXIST "ecl\atomic_ops" xcopy /S /Y "ecl\atomic_ops" "$(includedir)\atomic_ops\"
	cd c
	$(MAKE) /nologo cut.exe
	cd ..
	c\cut.exe < ecl\config.h > $(includedir)\ecl\config.h
	IF NOT EXIST "$(libdir)" $(MKDIR) "$(libdir)"
	IF NOT EXIST "$(libdir)\ecl" $(MKDIR) "$(libdir)\ecl"

=== msvc/c/Makefile ===
#
#			Makefile for ECL core library
#
top_srcdir = ..\..\src
srcdir	= ..\..\src\c

!if "$(ECL_WIN64)" != ""
ECL_FPE_CODE=fpe_none.c
!else
ECL_FPE_CODE=fpe_x86.c
!endif

!if "$(ECL_THREADS)" != ""
ECL_THREADS_FLAG=1
THREADS_OBJ= process.obj mutex.obj condition_variable.obj rwlock.obj \
             semaphore.obj barrier.obj mailbox.obj atomic.obj queue.obj
!else
ECL_THREADS_FLAG=0
THREADS_OBJ=
!endif

!if "$(ECL_UNICODE)" != ""
ECL_UNICODE_FLAG=21
ECL_UCD_OBJ = ucd.obj ucd-0000.obj ucd-0016.obj \
	      ucd-0032.obj ucd-0048.obj ucd-0064.obj \
	      ucd-0080.obj ucd-0096.obj ucd_names_char.obj ucd_names_codes.obj ucd_names_pair.obj ucd_names_str.obj

!else
ECL_UNICODE_FLAG=0
!endif

!if "$(ECL_SSE)" != ""
ECL_SSE_FLAG=1
ECL_SSE_OBJ=sse2.obj
!else
ECL_SSE_FLAG=0
ECL_SSE_OBJ=
!endif

!if "$(ECL_USE_DBGHELP)" != ""
ECL_USE_DBGHELP_FLAG=1
!else
ECL_USE_DBGHELP_FLAG=0
!endif

# Programs used by "make":
#
CC	= cl
CFLAGS	= -c $(ECL_CFLAGS) -DECL_BUILD -DECL_API="__declspec(dllexport)" -I./ -I../ -I$(srcdir) -I$(top_srcdir)/bdwgc/include  -I$(top_srcdir)/bdwgc/include/private -I$(srcdir)/unicode

SHELL	= /bin/sh
RM	= del
CP      = copy /Y
MV      = move /Y
LINK    = link
EXE	= .exe
DPP	= .\dpp$(EXE)

# Data for installation
#
INSTALL = @INSTALL@
INSTALL_DATA = @INSTALL_DATA@
prefix=@prefix@
exec_prefix=$(prefix)
libdir=$(prefix)\lib\ecl

# Files

HDIR	= $(top_srcdir)\h
HFILES	= ..\ecl\config.h ..\ecl\config-internal.h ..\ecl\atomic_ops.h \
	$(HDIR)\ecl.h $(HDIR)\ecl-cmp.h \
	$(HDIR)\object.h $(HDIR)\cs.h $(HDIR)\stacks.h \
	$(HDIR)\external.h $(HDIR)\cons.h $(HDIR)\legacy.h \
	$(HDIR)\number.h $(HDIR)\page.h \
	$(HDIR)\internal.h $(HDIR)\ecl-inl.h $(HDIR)\bytecodes.h \
	$(HDIR)\impl\math_dispatch.h $(HDIR)\impl\math_dispatch2.h \
	$(HDIR)\impl\math_fenv.h $(HDIR)\impl\math_fenv_msvc.h \
	$(HDIR)\cache.h $(HDIR)\stack-resize.h \
	$(HDIR)\ecl_atomics.h

OBJS	= main.obj symbol.obj package.obj cons.obj list.obj\
	apply.obj eval.obj \
	interpreter.obj compiler.obj disassembler.obj \
	instance.obj gfun.obj cache.obj accessor.obj \
	reference.obj character.obj\
	file.obj read.obj print.obj error.obj string.obj cfun.obj\
	parse_integer.obj parse_number.obj \
	float_to_digits.obj float_to_string.obj \
	integer_to_string.obj write_ugly.obj \
	write_object.obj write_symbol.obj \
	write_array.obj write_list.obj write_code.obj \
	write_sse.obj print_unreadable.obj \
	libraries.obj backtrace.obj mmap.obj cdata.obj \
	cos.obj sin.obj tan.obj atan.obj \
	cosh.obj sinh.obj tanh.obj \
	exp.obj expt.obj log.obj \
	sqrt.obj abs.obj \
	zerop.obj plusp.obj minusp.obj \
	negate.obj conjugate.obj \
	one_plus.obj one_minus.obj \
	plus.obj minus.obj times.obj divide.obj \
	number_compare.obj number_equalp.obj minmax.obj \
	floor.obj ceiling.obj round.obj truncate.obj \
	typespec.obj assignment.obj \
	predicate.obj big.obj number.obj\
	num_pred.obj num_arith.obj num_co.obj\
	num_log.obj num_rand.obj array.obj vector_push.obj \
	sequence.obj cmpaux.obj\
	macros.obj backq.obj stacks.obj \
	time.obj unixint.obj\
	mapfun.obj multival.obj hash.obj format.obj pathname.obj\
	structure.obj load.obj unixfsys.obj unixsys.obj \
	ffi.obj alloc_2.obj tcp.obj $(THREADS_OBJ) serialize.obj \
	$(ECL_UCD_OBJ) $(ECL_SSE_OBJ)

all:	$(DPP) ..\eclmin.lib ..\cinit.obj

.SUFFIXES: .obj .c .d

{$(srcdir:\=/)}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/arch}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/clos/}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/reader}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/printer}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/ffi}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/unicode}.c{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/numbers}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/threads}.d{}.c:
	$(DPP) $< $@

#.d.c:
#	$(DPP) $< $@
.c.obj:
	$(CC) $(CFLAGS) /Fo$@ $<

.PHONY:	all

cut.exe: $(top_srcdir)/util/cut.c
	$(CC) $(LDFLAGS) /Fecut.exe $(top_srcdir)/util/cut.c

..\eclmin.lib: $(OBJS:.obj=.c) all_symbols.c $(OBJS) all_symbols.obj all_symbols2.obj
	-$(RM) $@
	$(LINK) -lib -nologo -out:$@ $(OBJS)

clean:
	-for %f in ($(OBJS:.obj=.c) all_symbols.c) do $(RM) %f
	-for %f in ($(OBJS) all_symbols.obj all_symbols2.obj) do $(RM) %f
	-$(RM) *.pdb
	-for %f in (..\ecl\config.h dpp dpp.obj $(DPP) cut.exe cut.obj \
	            ..\eclmin.lib ..\cinit.obj cinit.c symbols_list2.h) \
	     do $(RM) %f
	-for %f in (..\ecl\*.h) do $(RM) %f
	-for %f in (cut.exe cut.obj dpp.exe dpp.obj) do $(RM) %f
	-del /S /Q ..\ecl\atomic_ops
	-del /S /Q ..\ecl\impl

# Build rules

$(DPP): $(srcdir)/dpp.c $(srcdir)/symbols_list2.h ../ecl/config.h ../ecl/config-internal.h
	$(CC) /nologo -I.. -I./ $(srcdir)/dpp.c /Fe$@
$(HFILES): ../ecl/config.h.msvc6 ../ecl/config-internal.h.msvc6 Makefile
	-mkdir ..\ecl\impl
	cut.exe "@ECL_FPE_CODE@" "$(srcdir:\=/)/arch/$(ECL_FPE_CODE)" \
		"@ECL_VERSION_NUMBER@" "$(ECL_VERSION_NUMBER)" \
                "@ECL_DEFAULT_C_STACK_SIZE@" "$(ECL_DEFAULT_C_STACK_SIZE)" \
		"@ECL_THREADS@" "$(ECL_THREADS_FLAG)" \
		"@ECL_UNICODE@" "$(ECL_UNICODE_FLAG)" \
		"@ECL_SSE2@" "$(ECL_SSE_FLAG)" \
		"@ECL_USE_DBGHELP@" "$(ECL_USE_DBGHELP_FLAG)" \
	        < ..\ecl\config.h.msvc6 > ..\ecl\config.h
	cut.exe "@ECL_FPE_CODE@" "$(srcdir:\=/)/arch/$(ECL_FPE_CODE)" \
		"@ECL_VERSION_NUMBER@" "$(ECL_VERSION_NUMBER)" \
                "@ECL_DEFAULT_C_STACK_SIZE@" "$(ECL_DEFAULT_C_STACK_SIZE)" \
		"@ECL_THREADS@" "$(ECL_THREADS_FLAG)" \
		"@ECL_UNICODE@" "$(ECL_UNICODE_FLAG)" \
		"@ECL_SSE2@" "$(ECL_SSE_FLAG)" \
		"@ECL_USE_DBGHELP@" "$(ECL_USE_DBGHELP_FLAG)" \
	        < ..\ecl\config-internal.h.msvc6 > ..\ecl\config-internal.h
	xcopy /SYI $(top_srcdir)\h\*.h ..\ecl
	-mkdir ..\ecl\atomic_ops
	-mkdir ..\ecl\atomic_ops\sysdeps
	xcopy /SYI $(top_srcdir)\bdwgc\libatomic_ops\src\atomic_ops.h ..\ecl
	xcopy /SYI $(top_srcdir)\bdwgc\libatomic_ops\src\atomic_ops\generalize*.h ..\ecl\atomic_ops
	xcopy /SYI $(top_srcdir)\bdwgc\libatomic_ops\src\atomic_ops\sysdeps\* ..\ecl\atomic_ops\sysdeps
	xcopy /SYI $(top_srcdir)\bdwgc\libatomic_ops\src\atomic_ops\ao_version.h ..\ecl\atomic_ops

#
# GCC might break this code
#
gbc.o: gbc.c $(HFILES)
	$(CC) $(CFLAGS) -O0 gbc.c /Fo$@
#
# This reduces the overhead of jumping to other functions
#
apply.o: apply.c $(HFILES) $(HDIR)/cs.h
	$(CC) $(CFLAGS) apply.c /Fo$@
#
# These files are interrelated
#
all_symbols.obj: all_symbols.c
	$(CC) $(CFLAGS) -Fo$@ -I../ -I./ all_symbols.c
all_symbols2.obj: all_symbols.c
	$(CC) $(CFLAGS) -DECL_FINAL -Fo$@ -I../ -I./ all_symbols.c
#
# This is in another directory
#
../cinit.obj: cinit.c
	$(CC) $(CFLAGS) -I../ -I./ /Focinit.obj cinit.c
	$(MV) cinit.obj ..\

=== debian/changelog ===
ecl (20.4.24+ds-2) unstable; urgency=medium

  * Add prevent-floating-point-exception.patch, fixing spurious SIGFPE's
    on ppc64el and ppc64.

 -- Tobias Hansen <thansen@debian.org>  Sat, 31 Oct 2020 11:07:11 +0000

ecl (20.4.24+ds-1) unstable; urgency=medium

  * New upstream release.
  * Backport upstream patches:
    - 210.patch
    - 214.patch
    - 215.patch
    - ECL_WITH_LISP_FPE.patch
  * Remove patches (applied upstream):
    - format-security.patch
    - libffi-3.3.patch
    - parallel-ftbfs.patch
  * Remove .gitlab-ci.yml from repacked orig tarball.

 -- Tobias Hansen <thansen@debian.org>  Sun, 30 Aug 2020 11:28:45 +0200

=== debian/control ===
Source: ecl
Section: lisp
Priority: optional
Maintainer: Debian Common Lisp Team <debian-common-lisp@lists.debian.org>
Uploaders: Peter Van Eynde <pvaneynd@debian.org>,
 Christoph Egger <christoph@debian.org>,
 Tobias Hansen <thansen@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 libgmp-dev,
 file,
 texinfo,
 libncurses5-dev,
 fakeroot,
 libgc-dev (>= 1:7.1),
 chrpath,
 install-info,
 libatomic-ops-dev,
 libffi-dev
Build-Conflicts: autoconf2.13
Standards-Version: 4.5.0
Homepage: https://common-lisp.net/project/ecl/
Vcs-Git: https://salsa.debian.org/common-lisp-team/ecl.git
Vcs-Browser: https://salsa.debian.org/common-lisp-team/ecl
Rules-Requires-Root: no

Package: ecl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libffi-dev, libgmp-dev, libncurses5-dev, libgc-dev, libatomic-ops-dev, gcc
Provides: lisp-compiler
Suggests: slime, ecl-doc
Description: Embeddable Common-Lisp: has an interpreter and can compile to C
 ECL stands for Embeddable Common-Lisp. The ECL project is an
 effort to modernize Giuseppe Attardi's ECL environment to
 produce an implementation of the Common-Lisp language
 which complies to the ANSI X3J13 definition of the language.
 .
 The current ECL implementation features:
  * A bytecodes compiler and interpreter.
  * A translator to C.
  * A UFFI-compatible interface to C code.
  * A dynamic loader.
  * The possibility to build standalone executables and DLLs.
  * The Common-Lisp Object System (CLOS).
  * Conditions and restarts for handling errors.
  * Sockets as ordinary streams.
  * The GNU Multiprecision library for fast bignum operations.
  * A simple conservative mark & sweep garbage collector.
  * The Boehm-Weiser garbage collector.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	touch src/configure.in && \
	touch src/aclocal.m4 && \
	touch src/configure configure

	dh_auto_configure -- \
	   --enable-gmp=system \
	   --with-tcp \
	   --enable-threads=yes \
	   --enable-boehm=system  \
	   --enable-libatomic=system \
	   --disable-rpath \
	   --with-x

override_dh_autoreconf:
	dh_autoreconf autoreconf -- -f -i src/

#mostly require remote access
override_dh_auto_test:

override_dh_auto_install:
	dh_auto_install
# fix lintian error package-contains-info-dir-file
	rm -f debian/ecl/usr/share/info/dir

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build
	rm -f src/configure.in

## ecl 21.2.1%2Bds

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: ecl
 Section: lisp
 Priority: optional
-Maintainer: Debian Common Lisp Team <debian-common-lisp@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Common Lisp Team <debian-common-lisp@lists.debian.org>
 Uploaders: Peter Van Eynde <pvaneynd@debian.org>,
  Christoph Egger <christoph@debian.org>,
  Tobias Hansen <thansen@debian.org>
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
  debhelper-compat (= 12),
  libgmp-dev,
  file,
@@ -18,7 +19,7 @@
  libatomic-ops-dev,
  libffi-dev
 Build-Conflicts: autoconf2.13
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://common-lisp.net/project/ecl/
 Vcs-Git: https://salsa.debian.org/common-lisp-team/ecl.git
 Vcs-Browser: https://salsa.debian.org/common-lisp-team/ecl
@@ -26,7 +27,9 @@
 
 Package: ecl
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libffi-dev, libgmp-dev, libncurses5-dev, libgc-dev, libatomic-ops-dev, gcc
+Depends: ${shlibs:Depends}, ${misc:Depends},
+ libecl21.2t64 (= ${binary:Version}), libecl-dev (= ${binary:Version}),
+ libffi-dev, libgmp-dev, libncurses5-dev, libgc-dev, libatomic-ops-dev, gcc
 Provides: lisp-compiler
 Suggests: slime, ecl-doc
 Description: Embeddable Common-Lisp: has an interpreter and can compile to C
@@ -47,3 +50,60 @@
   * The GNU Multiprecision library for fast bignum operations.
   * A simple conservative mark & sweep garbage collector.
   * The Boehm-Weiser garbage collector.
+
+Package: libecl21.2t64
+Provides: ${t64:Provides}
+Section: libs
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: libecl21.2 (<< ${source:Version}), ecl (<< 21.2.1+ds-2)
+Replaces: libecl21.2, ecl (<< 21.2.1+ds-2)
+Description: Embeddable Common-Lisp: shared library
+ ECL stands for Embeddable Common-Lisp. The ECL project is an
+ effort to modernize Giuseppe Attardi's ECL environment to
+ produce an implementation of the Common-Lisp language
+ which complies to the ANSI X3J13 definition of the language.
+ .
+ The current ECL implementation features:
+  * A bytecodes compiler and interpreter.
+  * A translator to C.
+  * A UFFI-compatible interface to C code.
+  * A dynamic loader.
+  * The possibility to build standalone executables and DLLs.
+  * The Common-Lisp Object System (CLOS).
+  * Conditions and restarts for handling errors.
+  * Sockets as ordinary streams.
+  * The GNU Multiprecision library for fast bignum operations.
+  * A simple conservative mark & sweep garbage collector.
+  * The Boehm-Weiser garbage collector.
+ .
+ This package contains the shared library.
+
+Package: libecl-dev
+Section: libdevel
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}, libecl21.2t64 (= ${binary:Version})
+Breaks: ecl (<< 21.2.1+ds-2)
+Replaces: ecl (<< 21.2.1+ds-2)
+Description: Embeddable Common-Lisp: development files
+ ECL stands for Embeddable Common-Lisp. The ECL project is an
+ effort to modernize Giuseppe Attardi's ECL environment to
+ produce an implementation of the Common-Lisp language
+ which complies to the ANSI X3J13 definition of the language.
+ .
+ The current ECL implementation features:
+  * A bytecodes compiler and interpreter.
+  * A translator to C.
+  * A UFFI-compatible interface to C code.
+  * A dynamic loader.
+  * The possibility to build standalone executables and DLLs.
+  * The Common-Lisp Object System (CLOS).
+  * Conditions and restarts for handling errors.
+  * Sockets as ordinary streams.
+  * The GNU Multiprecision library for fast bignum operations.
+  * A simple conservative mark & sweep garbage collector.
+  * The Boehm-Weiser garbage collector.
+ .
+ This package contains the development files.

## ecl 21.2.1+ds

=== msvc/Makefile ===
--- 
+++ 
@@ -10,8 +10,8 @@
 
 SHORT_SITE_NAME   =
 LONG_SITE_NAME    =
-ECL_VERSION       = 20.4.24
-ECL_VERSION_NUMBER= 200424
+ECL_VERSION       = 21.2.1
+ECL_VERSION_NUMBER= 210201
 ARCHITECTURE      = PENTIUM4
 SOFTWARE_TYPE     = NT
 SOFTWARE_VERSION  = 5.0

=== msvc/c/Makefile ===
--- 
+++ 
@@ -46,7 +46,7 @@
 # Programs used by "make":
 #
 CC	= cl
-CFLAGS	= -c $(ECL_CFLAGS) -DECL_BUILD -DECL_API="__declspec(dllexport)" -I./ -I../ -I$(srcdir) -I$(top_srcdir)/bdwgc/include  -I$(top_srcdir)/bdwgc/include/private -I$(srcdir)/unicode
+CFLAGS	= -c $(ECL_CFLAGS) -DECL_BUILD -DECL_API="__declspec(dllexport)" -I./ -I../ -I../ecl -I$(srcdir) -I$(srcdir)/unicode
 
 SHELL	= /bin/sh
 RM	= del
@@ -155,7 +155,7 @@
 	-for %f in ($(OBJS) all_symbols.obj all_symbols2.obj) do $(RM) %f
 	-$(RM) *.pdb
 	-for %f in (..\ecl\config.h dpp dpp.obj $(DPP) cut.exe cut.obj \
-	            ..\eclmin.lib ..\cinit.obj cinit.c symbols_list2.h) \
+	            ..\eclmin.lib ..\cinit.obj cinit.c) \
 	     do $(RM) %f
 	-for %f in (..\ecl\*.h) do $(RM) %f
 	-for %f in (cut.exe cut.obj dpp.exe dpp.obj) do $(RM) %f
@@ -164,7 +164,7 @@
 
 # Build rules
 
-$(DPP): $(srcdir)/dpp.c $(srcdir)/symbols_list2.h ../ecl/config.h ../ecl/config-internal.h
+$(DPP): $(srcdir)/dpp.c $(srcdir)/symbols_list.h ../ecl/config.h ../ecl/config-internal.h
 	$(CC) /nologo -I.. -I./ $(srcdir)/dpp.c /Fe$@
 $(HFILES): ../ecl/config.h.msvc6 ../ecl/config-internal.h.msvc6 Makefile
 	-mkdir ..\ecl\impl

=== msvc/gc/Makefile ===
# Makefile for Windows NT.  Assumes Microsoft compiler.
# DLLs are included in the root set under NT, but not under win32S.
# Use "nmake nodebug=1 all" for optimized versions of library, gctest and editor.
# MY_CPU=i386 for 32 bits or AMD64 for 64 bits
CPU=$(MY_CPU)
#!include <ntwin32.mak>

srcdir=..\..\src\bdwgc

!if "$(ECL_THREADS)" != ""
THREADS_OBJ= win32_threads.obj thread_local_alloc.obj
THREADS_FLAGS= -D_CRT_SECURE_NO_WARNINGS -DGC_DLL -DGC_BUILD -DGC_WIN32_THREADS -DTHREAD_LOCAL_ALLOC -DLARGE_CONFIG
!else
THREADS_OBJ=
THREADS_FLAGS= -D_CRT_SECURE_NO_WARNINGS -DGC_DLL -DGC_BUILD -DLARGE_CONFIG
!endif

# Make sure that .cc is not viewed as a suffix.  It is for VC++2005, but
# not earlier versions.  We can deal with either, but not inconsistency.
.SUFFIXES:
.SUFFIXES: .obj .cpp .c

# Atomic_ops installation directory.  For win32, the source directory
# should do, since we only need the headers.
# We assume this was manually unpacked, since I'm not sure there is
# a Windows standard command line tool to do this.
AO_SRC_DIR=$(srcdir)/libatomic_ops/src
AO_INCLUDE_DIR=$(AO_SRC_DIR)

OBJS= alloc.obj reclaim.obj allchblk.obj misc.obj mach_dep.obj os_dep.obj mark_rts.obj headers.obj mark.obj obj_map.obj blacklst.obj finalize.obj new_hblk.obj dbg_mlc.obj fnlz_mlc.obj malloc.obj stubborn.obj dyn_load.obj typd_mlc.obj ptr_chck.obj gc_cpp.obj mallocx.obj win32_threads.obj msvc_dbg.obj thread_local_alloc.obj

all: gc.lib

{$(srcdir)\extra}.c{}.obj:
	$(CC) -nologo -c -DWIN32 -D_MT $(CFLAGS_CONFIG) -Iinclude -I$(AO_INCLUDE_DIR) $(THREADS_FLAGS) -I$(srcdir)\include $< /Fo$*.obj

{$(srcdir)}.c{}.obj:
	$(CC) -nologo -c -DWIN32 -D_MT $(CFLAGS_CONFIG) -Iinclude -I$(AO_INCLUDE_DIR) $(THREADS_FLAGS) -I$(srcdir)\include $< /Fo$*.obj

{$(srcdir)}.cpp{}.obj:
	$(CC) -nologo -c -DWIN32 -D_MT $(CFLAGS_CONFIG) -Iinclude -I$(AO_INCLUDE_DIR) $(THREADS_FLAGS) -I$(srcdir)\include $< /Fo$*.obj

gc.lib: $(OBJS)
!if "$(CPU)" == "i386"
	lib /MACHINE:i386 /out:gc.lib $(OBJS)
!else
	lib /MACHINE:X64 /out:gc.lib $(OBJS)
!endif


gc_cpp.cpp: $(srcdir)\gc_cpp.cc
	copy $? $@

clean:
	-erase $(OBJS)
	-erase gc.lib
	-erase *.pdb

=== msvc/tests/Makefile ===
top_srcdir=..\..
ECLDIR=../package/
ECL=..\package\ecl.exe

.PHONY: all

all: check

check: config.lsp
	set ECLDIR=$(ECLDIR)
	$(ECL) -norc \
                -load config.lsp \
                -eval "(ecl-tests::run-tests '($(TESTS)))" \
                -eval "(ext:quit)"

config.lsp: $(top_srcdir)\src\tests\config.lsp.in ..\c\cut.exe Makefile
	..\c\cut.exe "@builddir@" "./" \
	          "@true_srcdir@" "../src" \
	  < $(top_srcdir)\src\tests\config.lsp.in > config.lsp

=== examples/threads/import/Makefile ===
#
# Read the comments in import.c
#

import.exe: import.c
	gcc -g `ecl-config --cflags` import.c -o $@ `ecl-config --ldflags`

=== debian/changelog ===
ecl (21.2.1+ds-4) unstable; urgency=medium

  * Add dependency on libecl-dev to ecl.

 -- Tobias Hansen <thansen@debian.org>  Sat, 15 Jan 2022 08:32:24 +0000

ecl (21.2.1+ds-3) unstable; urgency=medium

  * Install help.doc.

 -- Tobias Hansen <thansen@debian.org>  Fri, 14 Jan 2022 20:24:24 +0000

ecl (21.2.1+ds-2) unstable; urgency=medium

  * Provide library packages for libecl. (Closes: #1001541)

 -- Tobias Hansen <thansen@debian.org>  Mon, 10 Jan 2022 22:33:42 +0000

ecl (21.2.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Remove patches applied upstream:
    - 210.patch
    - 214.patch
    - 215.patch
    - ECL_WITH_LISP_FPE.patch
    - prevent-floating-point-exception.patch
  * Add lintian override for library-not-linked-against-libc.

 -- Tobias Hansen <thansen@debian.org>  Sat, 04 Dec 2021 10:12:16 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: ecl
 Section: lisp
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Common Lisp Team <debian-common-lisp@lists.debian.org>
+Maintainer: Debian Common Lisp Team <debian-common-lisp@lists.debian.org>
 Uploaders: Peter Van Eynde <pvaneynd@debian.org>,
  Christoph Egger <christoph@debian.org>,
  Tobias Hansen <thansen@debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5),
+Build-Depends:
  debhelper-compat (= 12),
  libgmp-dev,
  file,
@@ -28,7 +27,7 @@
 Package: ecl
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
- libecl21.2t64 (= ${binary:Version}), libecl-dev (= ${binary:Version}),
+ libecl21.2 (= ${binary:Version}), libecl-dev (= ${binary:Version}),
  libffi-dev, libgmp-dev, libncurses5-dev, libgc-dev, libatomic-ops-dev, gcc
 Provides: lisp-compiler
 Suggests: slime, ecl-doc
@@ -51,14 +50,13 @@
   * A simple conservative mark & sweep garbage collector.
   * The Boehm-Weiser garbage collector.
 
-Package: libecl21.2t64
-Provides: ${t64:Provides}
+Package: libecl21.2
 Section: libs
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Breaks: libecl21.2 (<< ${source:Version}), ecl (<< 21.2.1+ds-2)
-Replaces: libecl21.2, ecl (<< 21.2.1+ds-2)
+Breaks: ecl (<< 21.2.1+ds-2)
+Replaces: ecl (<< 21.2.1+ds-2)
 Description: Embeddable Common-Lisp: shared library
  ECL stands for Embeddable Common-Lisp. The ECL project is an
  effort to modernize Giuseppe Attardi's ECL environment to
@@ -84,7 +82,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libecl21.2t64 (= ${binary:Version})
+Depends: ${misc:Depends}, libecl21.2 (= ${binary:Version})
 Breaks: ecl (<< 21.2.1+ds-2)
 Replaces: ecl (<< 21.2.1+ds-2)
 Description: Embeddable Common-Lisp: development files

=== debian/rules ===
--- 
+++ 
@@ -30,6 +30,8 @@
 	dh_auto_install
 # fix lintian error package-contains-info-dir-file
 	rm -f debian/ecl/usr/share/info/dir
+	mkdir -p debian/ecl/usr/share/info/figures
+	cp src/doc/manual/figures/*.png debian/ecl/usr/share/info/figures/
 
 override_dh_auto_clean:
 	dh_auto_clean

## ecl 24.5.10+ds

=== msvc/Makefile ===
--- 
+++ 
@@ -10,8 +10,8 @@
 
 SHORT_SITE_NAME   =
 LONG_SITE_NAME    =
-ECL_VERSION       = 21.2.1
-ECL_VERSION_NUMBER= 210201
+ECL_VERSION       = 24.5.10
+ECL_VERSION_NUMBER= 240510
 ARCHITECTURE      = PENTIUM4
 SOFTWARE_TYPE     = NT
 SOFTWARE_VERSION  = 5.0
@@ -101,7 +101,7 @@
 !if "$(ECL_WIN64)" != ""
 GMP_BITS=64
 GC_CPU=AMD64
-ARCHITECTURE=AMD64
+ARCHITECTURE=X86-64
 VCREDIST=vcredist_x64.exe
 !else
 GMP_BITS=32
@@ -134,7 +134,7 @@
 CLIBS = $(CLIBS) DbgHelp.lib
 !endif
 
-CFLAGS  = /EHsc /DGC_DLL /DGC_BUILD /nologo /D_CRT_SECURE_NO_DEPRECATE $(CFLAGS_CONFIG)
+CFLAGS  = /EHsc /DGC_DLL /DGC_BUILD /nologo /wd4068 /wd4715 /wd4716 /D_CRT_SECURE_NO_DEPRECATE $(CFLAGS_CONFIG)
 LDFLAGS	= /link /incremental:no /nologo $(LDFLAGS_CONFIG) /STACK:$(ECL_DEFAULT_C_STACK_SIZE)
 
 
@@ -231,9 +231,9 @@
 	$(MAKE) cut$(EXE)
 	cd ..
 
-$(TARGETS): $(UCDDAT) ecl_min$(EXE) compile.lsp sysfun.lsp BUILD-STAMP
+$(TARGETS): $(UCDDAT) ecl_min$(EXE) compile.lsp BUILD-STAMP
 	set ECLDIR=./
-	ecl_min < compile.lsp
+	ecl_min compile
 BUILD-STAMP: Makefile
 	date /t > $@
 
@@ -274,6 +274,7 @@
 	    "@LDFLAGS@" "$(LDFLAGS)" \
 	    "@SHARED_LDFLAGS@" "$(SHARED_LDFLAGS)" \
 	    "@BUNDLE_LDFLAGS@" "$(SHARED_LDFLAGS)" \
+	    "@PROGRAM_LDFLAGS@" "" \
 	    "@CLIBS@" "$(CLIBS)" \
 	    "@STATICLIBS@" "$(STATICLIBS)" \
 	    "@LIBS@" "$(LIBS)" \
@@ -316,6 +317,7 @@
 	    "@LDFLAGS@" "$(LDFLAGS)" \
 	    "@SHARED_LDFLAGS@" "$(SHARED_LDFLAGS)" \
 	    "@BUNDLE_LDFLAGS@" "$(SHARED_LDFLAGS)" \
+	    "@PROGRAM_LDFLAGS@" "" \
 	    "@CLIBS@" "$(CLIBS)" \
 	    "@STATICLIBS@" "$(STATICLIBS)" \
 	    "@OBJEXT@" "obj" \
@@ -353,6 +355,7 @@
 	        ECL_THREADS=$(ECL_THREADS) ECL_UNICODE=$(ECL_UNICODE) \
 		ECL_SSE=$(ECL_SSE) ECL_WIN64=$(ECL_WIN64) \
 		ECL_USE_DBGHELP=$(ECL_USE_DBGHELP) \
+		ECL_ARCHITECTURE=$(ARCHITECTURE) \
 		"ECL_CFLAGS=$(CFLAGS) -DGC_BUILD"
 	cd ..
 eclgc.lib:
@@ -375,9 +378,6 @@
 	$(CP) gmp.lib ..\eclgmp.lib
 	$(CP) gmp.h ..\ecl\gmp.h
 	cd ..
-
-sysfun.lsp:
-	$(CP) $(srcdir)\cmp\sysfun.lsp .\
 
 install:
 	IF NOT EXIST "$(prefix)" $(MKDIR) "$(prefix)"
@@ -400,4 +400,3 @@
 	cd ..
 	c\cut.exe < ecl\config.h > $(includedir)\ecl\config.h
 	IF NOT EXIST "$(libdir)" $(MKDIR) "$(libdir)"
-	IF NOT EXIST "$(libdir)\ecl" $(MKDIR) "$(libdir)\ecl"

=== examples/embed/Makefile ===
hello.exe: hello.c hello-lisp.a
	$(CC) `ecl-config --cflags` -o $@ hello.c hello-lisp.a \
	      `ecl-config --ldflags` -lecl

hello-lisp.a: hello-lisp.lisp
	ecl -norc \
	    -eval '(require :asdf)' \
	    -eval '(push "./" asdf:*central-registry*)' \
	    -eval '(asdf:make-build :hello-lisp :type :static-library :move-here "./" :init-name "init_lib_HELLO_LISP")' \
	    -eval '(quit)'

clean:
	-rm -f hello-lisp.a hello.exe

=== msvc/c/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 !if "$(ECL_THREADS)" != ""
 ECL_THREADS_FLAG=1
 THREADS_OBJ= process.obj mutex.obj condition_variable.obj rwlock.obj \
-             semaphore.obj barrier.obj mailbox.obj atomic.obj queue.obj
+             semaphore.obj barrier.obj mailbox.obj atomic.obj
 !else
 ECL_THREADS_FLAG=0
 THREADS_OBJ=
@@ -23,7 +23,8 @@
 ECL_UNICODE_FLAG=21
 ECL_UCD_OBJ = ucd.obj ucd-0000.obj ucd-0016.obj \
 	      ucd-0032.obj ucd-0048.obj ucd-0064.obj \
-	      ucd-0080.obj ucd-0096.obj ucd_names_char.obj ucd_names_codes.obj ucd_names_pair.obj ucd_names_str.obj
+	      ucd-0080.obj ucd-0096.obj ucd-0112.obj \
+         ucd-0128.obj ucd-0144.obj ucd_names_char.obj ucd_names_codes.obj ucd_names_pair.obj ucd_names_str.obj
 
 !else
 ECL_UNICODE_FLAG=0
@@ -183,6 +184,7 @@
 		"@ECL_UNICODE@" "$(ECL_UNICODE_FLAG)" \
 		"@ECL_SSE2@" "$(ECL_SSE_FLAG)" \
 		"@ECL_USE_DBGHELP@" "$(ECL_USE_DBGHELP_FLAG)" \
+		"@ARCHITECTURE@" "$(ECL_ARCHITECTURE)" \
 	        < ..\ecl\config-internal.h.msvc6 > ..\ecl\config-internal.h
 	xcopy /SYI $(top_srcdir)\h\*.h ..\ecl
 	-mkdir ..\ecl\atomic_ops

=== src/doc/manual/Makefile ===
FILES= *.txi */*.txi figures/*

.PHONY: all pdf info html

all: pdf info html

pdf: manual.pdf
info: ecl.info.gz
html: html/index.html

manual.pdf: $(FILES)
	texi2pdf manual.txi

ecl.info.gz: $(FILES)
	$(MAKEINFO) --no-split manual.txi
	gzip < ecl.info > ecl.info.gz

html/index.html: $(FILES)
	$(MAKEINFO) --html --css-include=ecl.css --split=section manual.txi
	rm -rf html
	mv ecl html
	cp -r figures html

clean:
	rm -rf *.{aux,cf,cfs,cp,cpp,cpps,cps,ex,exs,fn,fns,ft,fts,log,lsp,lsps,toc,tp,tps,vr,vrs,pdf,info,info-1,info-2,info.gz,html} html

=== debian/changelog ===
ecl (24.5.10+ds-1) unstable; urgency=medium

  * New upstream version 24.5.10+ds
  * Depend on libncurses-dev instead of libncurses5-dev
  * Future-proof by disabling LTO support, with thanks to Steve Langasek. (Closes: 1069910)
  * Adjust lintian warnings
  * Adjust library soname with new version
  * Adjusted copyright file

 -- Peter Van Eynde <pvaneynd@debian.org>  Wed, 01 Jan 2025 10:53:47 +0100

ecl (21.2.1+ds-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062520

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 02:42:24 +0000

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,12 @@
 Uploaders: Peter Van Eynde <pvaneynd@debian.org>,
  Christoph Egger <christoph@debian.org>,
  Tobias Hansen <thansen@debian.org>
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
  debhelper-compat (= 12),
  libgmp-dev,
  file,
  texinfo,
- libncurses5-dev,
+ libncurses-dev,
  fakeroot,
  libgc-dev (>= 1:7.1),
  chrpath,
@@ -18,7 +18,7 @@
  libatomic-ops-dev,
  libffi-dev
 Build-Conflicts: autoconf2.13
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Homepage: https://common-lisp.net/project/ecl/
 Vcs-Git: https://salsa.debian.org/common-lisp-team/ecl.git
 Vcs-Browser: https://salsa.debian.org/common-lisp-team/ecl
@@ -27,8 +27,8 @@
 Package: ecl
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
- libecl21.2 (= ${binary:Version}), libecl-dev (= ${binary:Version}),
- libffi-dev, libgmp-dev, libncurses5-dev, libgc-dev, libatomic-ops-dev, gcc
+ libecl24.5t64 (= ${binary:Version}), libecl-dev (= ${binary:Version}),
+ libffi-dev, libgmp-dev, libncurses-dev, libgc-dev, libatomic-ops-dev, gcc
 Provides: lisp-compiler
 Suggests: slime, ecl-doc
 Description: Embeddable Common-Lisp: has an interpreter and can compile to C
@@ -50,13 +50,14 @@
   * A simple conservative mark & sweep garbage collector.
   * The Boehm-Weiser garbage collector.
 
-Package: libecl21.2
+Package: libecl24.5t64
+Provides: ${t64:Provides}
 Section: libs
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Breaks: ecl (<< 21.2.1+ds-2)
-Replaces: ecl (<< 21.2.1+ds-2)
+Breaks: libecl21.2, libecl24.5 (<< ${source:Version}), ecl (<< 24.5.10+ds-1)
+Replaces: libecl21.2, libecl24.5, ecl (<< 24.5.10+0ds-1)
 Description: Embeddable Common-Lisp: shared library
  ECL stands for Embeddable Common-Lisp. The ECL project is an
  effort to modernize Giuseppe Attardi's ECL environment to
@@ -82,9 +83,9 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libecl21.2 (= ${binary:Version})
-Breaks: ecl (<< 21.2.1+ds-2)
-Replaces: ecl (<< 21.2.1+ds-2)
+Depends: ${misc:Depends}, libecl24.5t64 (= ${binary:Version})
+Breaks: ecl (<< 24.5.10+ds-1)
+Replaces: ecl (<< 24.5.10+ds-1)
 Description: Embeddable Common-Lisp: development files
  ECL stands for Embeddable Common-Lisp. The ECL project is an
  effort to modernize Giuseppe Attardi's ECL environment to

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+export DEB_BUILD_MAINT_OPTIONS=optimize=-lto
 
 %:
 	dh $@

## ecl 24.5.10.20250914.git294da20%2Bdfsg

=== src/doc/old-manual/Makefile ===
XMLTO = xmlto
XSLTPROC = xsltproc

GEN_XMLFILES= tmp/COPYING.GFDL.xml
XMLFILES= ecl.xml bibliography.xmlf clos.xmlf compiler.xmlf			\
	declarations.xmlf ecldev.xmlf						\
	internals.xmlf interpreter.xmlf preface.xmlf				\
	io.xmlf mp.xmlf asdf.xmlf os.xmlf pde.xmlf				\
	copyright.xmlf ffi.xmlf ref_os.xmlf					\
	uffi/ref_primitive.xml uffi/ref_aggregate.xml uffi/ref_object.xml	\
	uffi/ref_string.xml uffi/ref_func_libr.xml				\
	mp.xmlf ref_mp.xmlf memory.xmlf ref_memory.xmlf				\
	mop.xmlf embed.xmlf ref_embed.xmlf signals.xmlf				\
	ansi_arrays.xml ansi_overview.xml					\
	ansi_characters.xml ansi_packages.xml ansi_conses.xml			\
	ansi_printer.xml ansi_data_flow.xml ansi_reader.xml			\
	ansi_environment.xml ansi_sequences.xml	ansi_evaluation.xml		\
	ansi_streams.xml ansi_filenames.xml ansi_strings.xml			\
	ansi_files.xml ansi_structures.xml ansi_hash_tables.xml			\
	ansi_symbols.xml ansi_numbers.xml ansi_system_construction.xml		\
	ansi_objects.xml ansi_types.xml						\
	ref_c_evaluation.xml ref_c_data_flow.xml ref_c_symbols.xml		\
	ref_c_numbers.xml ref_c_characters.xml ref_c_strings.xml		\
	ref_c_conses.xml ref_c_hash_tables.xml ref_c_sequences.xml		\
	ref_c_filenames.xml ref_c_packages.xml ref_c_printer.xml		\
	ref_c_system_construction.xml ref_c_environment.xml			\
	ref_c_objects.xml ref_c_conditions.xml ref_c_structures.xml		\
	ref_signals.xmlf ref_c_arrays.xml $(GEN_XMLFILES)

HTML_XSLFILES= xsl/customization.xml xsl/lispfunc.xml xsl/refentryintoc.xml
PDF_XSLFILES= xsl/customization.xml xsl/lispfunc-po.xml

all: html/ecl.css

ecl2.xml: $(XMLFILES) xsl/add_indexterm.xml
	@test -d html || mkdir html
	$(XSLTPROC) --xinclude xsl/add_indexterm.xml ecl.xml | \
	sed 's, xmlns="",,g;s,&#151,,g;' > ecl2.xml
html/index.html: ecl2.xml $(HTML_XSLFILES)
	$(XMLTO) -vv --skip-validation $(subst xsl, -m xsl,$(HTML_XSLFILES)) -o html html ecl2.xml
	cp ecl.css html/
html/ecl.css: ecl.css html/index.html
	cp ecl.css html/
	@test -d html/figures || mkdir html/figures
	cp figures/*.png html/figures/
ecl.pdf: ecl2.xml $(PDF_XSLFILES)
	-mkdir tex
	dblatex -V -d --tmpdir=tex -P latex.encoding=utf8 ecl2.xml
	mv ecl2.pdf $@

tmp/ecl.ent: ecl.ent
	cp $< $@

tmp/COPYING.GFDL.xml: COPYING.GFDL Makefile
	echo '<![CDATA[' > $@
	cat $< >> $@
	echo ']]>' >> $@

jing:
	jing -t -i /usr/local/Cellar/docbook/5.0/docbook/xml/5.0/rng/docbookxi.rnc ecl.xml

clean:
	rm -f tmp/ecl.ent ecl2.xml $(GEN_XMLFILES) html/*.html ecl.pdf
	rm -rf tex
